Index: s390-tools-sles11/iucvterm/test/test_functions.c
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/test/test_functions.c
@@ -0,0 +1,243 @@
+/*
+ * test_functions - Test program for the IUCV Terminal Applications
+ *
+ * Test program for the common functions used by the
+ * IUCV Terminal Applications
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <sys/ioctl.h>
+#include <termio.h>
+#include <unistd.h>
+#include "iucvterm/proto.h"
+#include "iucvterm/functions.h"
+#include "test.h"
+
+
+#define BUF_SIZE	256
+
+
+static int __testReadWriteMessage(int[2]);
+static int __testReadWriteMessage_chunks(int[2]);
+static int __testReadWriteMessage_nochunks(int[2]);
+static int __testTransmitData(int[2]);
+static int __testTermEnvVar(int[2]);
+static int __testWinsize(int[2]);
+static int __testCopyData(int[2]);
+
+
+int main(void)
+{
+	int sockv[2];
+
+	__socketpair(sockv);
+
+	assert(!__testReadWriteMessage(sockv));
+	assert(!__testReadWriteMessage_chunks(sockv));
+	assert(!__testReadWriteMessage_nochunks(sockv));
+	assert(!__testTermEnvVar(sockv));
+	assert(!__testWinsize(sockv));
+	assert(!__testCopyData(sockv));
+	assert(!__testTransmitData(sockv));
+
+	close(sockv[0]);
+	close(sockv[1]);
+
+	return 0;
+}
+
+
+static int __testReadWriteMessage_chunks(int sv[2])
+{
+	struct iucvtty_msg *msg[2];
+	char data[] = "Hallo\0test1\0test2\0test3\0test4\0test5\0test6\0test7\0test8";
+	size_t chunk;
+	int i;
+
+	/* setup msg to be sent */
+	msg[0] = msg_alloc(MSG_TYPE_DATA, BUF_SIZE);
+	msg[1] = msg_alloc(MSG_TYPE_DATA, BUF_SIZE);
+
+	/* send msg */
+	msg_cpy_from(msg[0], data, sizeof(data));
+	if (iucvtty_write_msg(sv[0], msg[0]))
+		return 1;
+
+	/* read msg */
+	chunk = 0;
+	for (i = 0; i < 9; i++) {
+		if (iucvtty_read_msg(sv[1], msg[1], 6 + MSG_DATA_OFFSET, &chunk))
+			return 2;
+		assert(msg[1]->datalen == 6);
+		assert(0 == memcmp(msg[1]->data, data + (i * 6), msg[1]->datalen));
+		/*
+		printf("chunk=%i datalen=%u data='%s'\n",
+			chunk, msg[1]->datalen, msg[1]->data);
+		*/
+	}
+	assert(chunk == 0);
+
+	msg_free(msg[0]);
+	msg_free(msg[1]);
+
+	return 0;
+}
+
+static int __testReadWriteMessage_nochunks(int sv[2])
+{
+	struct iucvtty_msg *msg[2];
+	char data[] = "Hallo\0test1\0test2\0test3\0test4\0test5\0test6\0test7\0test8";
+	int i;
+	size_t residual = 0;
+
+	/* setup msg to be sent */
+	msg[0] = msg_alloc(MSG_TYPE_DATA, BUF_SIZE);
+	msg[1] = msg_alloc(MSG_TYPE_DATA, BUF_SIZE);
+
+	/* send and read msg .. with chunks disabled.
+	 * The iucvtty_read_msg() shall ignore any data more than the given
+	 * length. */
+	i = 7;
+	while (i--) {
+		msg_cpy_from(msg[0], data, sizeof(data));
+		if (iucvtty_write_msg(sv[0], msg[0]))
+			return 1;
+
+		/* read msg */
+		if (iucvtty_read_msg(sv[1], msg[1], 6 + MSG_DATA_OFFSET, &residual))
+			return 2;
+		assert(0 == memcmp(msg[1]->data, data, msg[1]->datalen));
+		iucvtty_skip_msg_residual(sv[1], &residual);
+		assert(0 == residual);
+		/*printf("datalen=%u data='%s'\n",
+			msg[1]->datalen, msg[1]->data);*/
+	}
+
+	msg_free(msg[0]);
+	msg_free(msg[1]);
+
+	return 0;
+}
+
+static int __testReadWriteMessage(int sv[2])
+{
+	struct iucvtty_msg *msg[2];
+	char data[10] = "Hallo";
+	size_t chunk = 0;
+
+	/* setup msg to be sent */
+	msg[0] = msg_alloc(MSG_TYPE_DATA, BUF_SIZE);
+	msg[1] = msg_alloc(MSG_TYPE_DATA, BUF_SIZE);
+
+	/* send msg */
+	msg_cpy_from(msg[0], data, sizeof(data));
+	if (iucvtty_write_msg(sv[0], msg[0]))
+		return 1;
+
+	/* read msg */
+	if (iucvtty_read_msg(sv[1], msg[1], BUF_SIZE, &chunk))
+		return 2;
+	iucvtty_skip_msg_residual(sv[1], &chunk);
+
+	/* compare msg */
+	if (__msgcmp(msg[0], msg[1]))
+		return 3;
+
+	msg_free(msg[0]);
+	msg_free(msg[1]);
+
+	return 0;
+}
+
+static int __testTransmitData(int sv[2])
+{
+	struct iucvtty_msg *msg;
+	char data[] = "Vah __testTransmitData hai.";
+	size_t chunk = 0;
+
+
+	/* I. write something to sv[0]
+	 * II. tx_data: read from sv[1], write to sv[0]
+	 * III. read iucvtty_msg from sv[1]
+	 */
+	assert(sizeof(data) == write(sv[0], data, sizeof(data)));
+	msg = msg_alloc(MSG_TYPE_DATA, BUF_SIZE);
+	assert(0 == iucvtty_tx_data(sv[0], sv[1], msg, BUF_SIZE));
+	assert(0 == iucvtty_read_msg(sv[1], msg, BUF_SIZE, &chunk));
+	assert(MSG_TYPE_DATA == msg->type);
+	assert(sizeof(data) == msg->datalen);
+	assert(0 == memcmp(&data, msg->data, msg->datalen));
+
+	msg_free(msg);
+	return 0;
+}
+
+static int __testTermEnvVar(int sv[2])
+{
+#define __BUF_SIZE 81
+	char term[__BUF_SIZE] = "my_default_term";
+	char buf[__BUF_SIZE];
+	char *orig_term = getenv("TERM");
+
+	/* I. */
+	if (orig_term != NULL) {
+		assert(0 == iucvtty_tx_termenv(sv[0], NULL));
+		assert(0 == iucvtty_rx_termenv(sv[1], buf, __BUF_SIZE));
+		assert(0 == strncmp(orig_term, buf,
+				    min(__BUF_SIZE, strlen(orig_term))));
+	}
+
+	unsetenv("TERM");	/* clear term */
+
+	/* II. */
+	assert(0 == iucvtty_tx_termenv(sv[0], term));
+	assert(0 == iucvtty_rx_termenv(sv[1], buf, __BUF_SIZE));
+	assert(0 == strncmp(buf, term, __BUF_SIZE));
+
+	/* III. */
+	assert(0 == iucvtty_tx_termenv(sv[0], NULL));
+	assert(0 == iucvtty_rx_termenv(sv[1], buf, __BUF_SIZE));
+	assert(0 == strncmp("", buf, 1));
+
+	setenv("TERM", orig_term, 1);	/* restore original term */
+	return 0;
+#undef __BUF_SIZE
+}
+
+static int __testWinsize(int sv[2])
+{
+	struct iucvtty_msg *msg;
+	struct winsize winsz;
+	size_t chunk;
+
+	msg = msg_alloc(MSG_TYPE_DATA, BUF_SIZE);
+	assert(0 == ioctl(STDIN_FILENO, TIOCGWINSZ, &winsz));
+	assert(0 == iucvtty_tx_winsize(sv[0], STDIN_FILENO));
+	assert(0 == iucvtty_read_msg(sv[1], msg, BUF_SIZE, &chunk));
+	assert(MSG_TYPE_WINSIZE == msg->type);
+	assert(sizeof(struct winsize) == msg->datalen);
+	assert(0 == memcmp(&winsz, msg->data, msg->datalen));
+
+	msg_free(msg);
+	return 0;
+}
+
+static int __testCopyData(int sv[2])
+{
+	struct iucvtty_msg *msg;
+	char data[] = "palim palim";
+	char buf[BUF_SIZE];
+
+	msg = msg_alloc(MSG_TYPE_DATA, BUF_SIZE);
+	msg_cpy_from(msg, data, sizeof(data));
+	assert(0 == iucvtty_copy_data(sv[0], msg));
+	assert(sizeof(data) == read(sv[1], &buf, BUF_SIZE));
+	assert(0 == memcmp(data, buf, sizeof(data)));
+
+	msg_free(msg);
+	return 0;
+}
Index: s390-tools-sles11/libvtoc/vtoc.c
===================================================================
--- s390-tools-sles11.orig/libvtoc/vtoc.c
+++ s390-tools-sles11/libvtoc/vtoc.c
@@ -218,19 +218,37 @@ void vtoc_set_extent (extent_t *ext, u_i
 /*
  *
  */
-void vtoc_set_cchh (cchh_t *addr, u_int16_t cc, u_int16_t hh) 
+void vtoc_set_cchh (cchh_t *addr, u_int32_t cc, u_int16_t hh)
 {
-        addr->cc = cc;
-	addr->hh = hh;
+	addr->cc = (u_int16_t) cc;
+	addr->hh = cc >> 16;
+	addr->hh <<= 4;
+	addr->hh |= hh;
 }
 
+u_int32_t vtoc_get_cyl_from_cchh(cchh_t *addr)
+{
+        u_int32_t cyl;
+
+        /*decode cylinder for large volumes */
+	cyl = addr->hh & 0xFFF0;
+	cyl <<= 12;
+	cyl |= addr->cc;
+	return cyl;
+}
+
+u_int16_t vtoc_get_head_from_cchh(cchh_t *addr)
+{
+	/* decode heads for large volumes */
+	return addr->hh & 0x000F;
+}
 
 /*
  *
  */
-static void vtoc_set_ttr (ttr_t *addr, u_int16_t tt, u_int8_t r) 
+static void vtoc_set_ttr (ttr_t *addr, u_int16_t tt, u_int8_t r)
 {
-        addr->tt = tt;
+	addr->tt = tt;
 	addr->r  = r;
 }
 
@@ -238,13 +256,58 @@ static void vtoc_set_ttr (ttr_t *addr, u
 /*
  *
  */
-void vtoc_set_cchhb (cchhb_t *addr, u_int16_t cc, u_int16_t hh, u_int8_t b) 
+void vtoc_set_cchhb (cchhb_t *addr, u_int32_t cc, u_int16_t hh, u_int8_t b)
+{
+	addr->cc = (u_int16_t) cc;
+	addr->hh = cc >> 16;
+	addr->hh <<= 4;
+	addr->hh |= hh;
+	addr->b  = b;
+}
+
+u_int32_t vtoc_get_cyl_from_cchhb(cchhb_t *addr)
 {
-        addr->cc = cc;
-        addr->hh = hh;
-        addr->b  = b;
+        u_int32_t cyl;
+
+        /* decode cylinder for large volumes */
+        cyl = addr->hh & 0xFFF0;
+        cyl <<= 12;
+        cyl |= addr->cc;
+	return cyl;
 }
 
+u_int16_t vtoc_get_head_from_cchhb(cchhb_t *addr)
+{
+	/* decode heads for large volumes */
+	return addr->hh & 0x000F;
+}
+
+/*
+ * some functions to convert cyl-cyl-head-head addresses to
+ * block or track numbers
+ * Note: Record zero is special, so first block on a track is
+ * in record 1!
+ */
+u_int64_t cchhb2blk(cchhb_t *p, struct hd_geometry *geo)
+{
+        return (u_int64_t) vtoc_get_cyl_from_cchhb(p) *
+		geo->heads * geo->sectors +
+		vtoc_get_head_from_cchhb(p) * geo->sectors +
+		p->b;
+}
+
+u_int64_t cchh2blk (cchh_t *p, struct hd_geometry *geo) {
+
+        return (u_int64_t) vtoc_get_cyl_from_cchh(p) *
+		geo->heads * geo->sectors +
+                vtoc_get_head_from_cchh(p) * geo->sectors;
+}
+
+u_int32_t cchh2trk (cchh_t *p, struct hd_geometry *geo) {
+
+	return  vtoc_get_cyl_from_cchh(p) * geo->heads +
+		vtoc_get_head_from_cchh(p);
+}
 
 /*
  *
@@ -481,7 +544,8 @@ vtoc_write_label (char *device,
 		  format1_label_t *f1, 
 		  format4_label_t *f4,
 		  format5_label_t *f5,
-		  format7_label_t *f7)
+		  format7_label_t *f7,
+		  format9_label_t *f9)
 {
 	int f,t;
 
@@ -542,6 +606,17 @@ vtoc_write_label (char *device,
 		}
 	}
 
+	if (f9 != NULL)
+	{
+		t = sizeof(format9_label_t);
+	        if (write(f, f9, t) != t)
+		{
+		        close(f);
+			vtoc_error(unable_to_write, device,
+				   "Could not write VTOC FMT9 DSCB.");
+		}
+	}
+
         close(f);
 }
 
@@ -553,7 +628,8 @@ void 
 vtoc_init_format4_label (
 	format4_label_t    *f4,
 	unsigned int usable_partitions,
-	unsigned int cylinders,
+	unsigned int compat_cylinders,
+	unsigned int real_cylinders,
 	unsigned int tracks,
 	unsigned int blocks,
 	unsigned int blksize,
@@ -578,7 +654,7 @@ vtoc_init_format4_label (
         f4->DS4DEVAC = 0x00;
 
         /* -- begin f4->DS4DEVCT -- */
-        f4->DS4DEVCT.DS4DSCYL = cylinders;
+        f4->DS4DEVCT.DS4DSCYL = compat_cylinders;
         f4->DS4DEVCT.DS4DSTRK = tracks;
 
 	switch (dev_type)
@@ -619,7 +695,11 @@ vtoc_init_format4_label (
 	bzero(f4->res2, sizeof(f4->res2));
 	f4->DS4EFLVL = 0x00;
 	bzero(&f4->DS4EFPTR, sizeof(f4->DS4EFPTR));
-	bzero(f4->res3, sizeof(f4->res3));
+	bzero(&f4->res3, sizeof(f4->res3));
+	f4->DS4DCYL = real_cylinders;
+	bzero(f4->res4, sizeof(f4->res4));
+	f4->DS4DEVF2 = 0x40; /* allow format 8 and 9 labels */
+	bzero(&f4->res5, sizeof(f4->res5));
 }
 
 
@@ -652,16 +732,16 @@ vtoc_init_format7_label (format7_label_t
 
 
 /*
- * initializes a format1 label
+ * helper function that initializes a most parts of a
+ * format1 or format 8 label, all but the field DS1FMTID
  */
-void 
-vtoc_init_format1_label (
+static void vtoc_init_format_1_8_label (
 	char *volid,
         unsigned int blksize,
 	extent_t *part_extent,
-	format1_label_t *f1) 
+	format1_label_t *f1)
 {
-        struct tm * creatime;
+	struct tm * creatime;
 	time_t t;
 	char str[80];
 
@@ -673,53 +753,87 @@ vtoc_init_format1_label (
 	sprintf(str, "PART    .NEW                                ");
 	vtoc_ebcdic_enc(str, str, 44);
 	strncpy(f1->DS1DSNAM, str, 44);
-	f1->DS1FMTID = 0xf1;
 	strncpy((char *) f1->DS1DSSN, "      ", 6);
 	f1->DS1VOLSQ = 0x0001;
 
 	vtoc_set_date(&f1->DS1CREDT,
-                      (u_int8_t) creatime->tm_year,
+		      (u_int8_t) creatime->tm_year,
 		      (u_int16_t) creatime->tm_yday);
 	/* expires never - 99 365 */
-        vtoc_set_date(&f1->DS1EXPDT,
+	vtoc_set_date(&f1->DS1EXPDT,
 	              0x63,
-                      0x016D);
+		      0x016D);
 	f1->DS1NOEPV = 0x01;
 	f1->DS1NOBDB = 0x00;
-        f1->DS1FLAG1 = 0x00;
+	f1->DS1FLAG1 = 0x00;
 	vtoc_ebcdic_enc("IBM LINUX    ", str, 13);
 	strncpy((char *)f1->DS1SYSCD, str, 13);
-        vtoc_set_date(&f1->DS1REFD,
+	vtoc_set_date(&f1->DS1REFD,
 		      (u_int8_t) creatime->tm_year,
-                      (u_int16_t) creatime->tm_yday);
-        f1->DS1SMSFG = 0x00;
-        f1->DS1SCXTF = 0x00;
-        f1->DS1SCXTV = 0x0000;
-        f1->DS1DSRG1 = 0x00;
-        f1->DS1DSRG2 = 0x00;
-        f1->DS1RECFM = 0x88;
-        f1->DS1OPTCD = 0x00;
-        f1->DS1BLKL  = blksize;
-        f1->DS1LRECL = blksize;
-        f1->DS1KEYL  = 0x00;
-        f1->DS1RKP   = 0x0000;
-        f1->DS1DSIND = 0x80; /* last volume for this dataset */
-        f1->DS1SCAL1 = 0x80;
-        bzero(&f1->DS1SCAL3, sizeof(f1->DS1SCAL3));
+		      (u_int16_t) creatime->tm_yday);
+	f1->DS1SMSFG = 0x00;
+	f1->DS1SCXTF = 0x00;
+	f1->DS1SCXTV = 0x0000;
+	f1->DS1DSRG1 = 0x00;
+	f1->DS1DSRG2 = 0x00;
+	f1->DS1RECFM = 0x88;
+	f1->DS1OPTCD = 0x00;
+	f1->DS1BLKL  = blksize;
+	f1->DS1LRECL = blksize;
+	f1->DS1KEYL  = 0x00;
+	f1->DS1RKP   = 0x0000;
+	f1->DS1DSIND = 0x80; /* last volume for this dataset */
+	f1->DS1SCAL1 = 0x80;
+	bzero(&f1->DS1SCAL3, sizeof(f1->DS1SCAL3));
 	vtoc_set_ttr(&f1->DS1LSTAR,
-	             0x0000,
-	             0x00);
+		     0x0000,
+		     0x00);
 	f1->DS1TRBAL = 0x00;
 	bzero(&f1->res1, sizeof(f1->res1));
-        memcpy(&f1->DS1EXT1,
-               part_extent,
-               sizeof(extent_t));
-        bzero(&f1->DS1EXT2, sizeof(extent_t));
-        bzero(&f1->DS1EXT3, sizeof(extent_t));
-        vtoc_set_cchhb(&f1->DS1PTRDS,
-                       0x0000, 0x0000, 0x00);
+	memcpy(&f1->DS1EXT1,
+	       part_extent,
+	       sizeof(extent_t));
+	bzero(&f1->DS1EXT2, sizeof(extent_t));
+	bzero(&f1->DS1EXT3, sizeof(extent_t));
+	vtoc_set_cchhb(&f1->DS1PTRDS,
+		       0x0000, 0x0000, 0x00);
+}
+
+void vtoc_init_format1_label (
+	char *volid,
+        unsigned int blksize,
+	extent_t *part_extent,
+	format1_label_t *f1)
+{
+	vtoc_init_format_1_8_label(volid, blksize, part_extent, f1);
+	f1->DS1FMTID = 0xf1;
 }
 
+void vtoc_init_format8_label (
+	char *volid,
+        unsigned int blksize,
+	extent_t *part_extent,
+	format1_label_t *f8)
+{
+	vtoc_init_format_1_8_label(volid, blksize, part_extent, f8);
+	f8->DS1FMTID = 0xf8;
+}
+
+void vtoc_update_format8_label (
+	cchhb_t *associated_f9,
+	format1_label_t *f8)
+{
+	memcpy(&f8->DS1PTRDS, associated_f9, sizeof(*associated_f9));
+}
+
+void vtoc_init_format9_label (
+	format9_label_t *f9)
+{
+	f9->DS9KEYID = 0x09;
+	f9->DS9SUBTY = 0x01;
+	f9->DS9NUMF9 = 1;
+	f9->DS9FMTID = 0xf9;
+}
 
 /*
  * do some updates to the VTOC format4 label
@@ -1193,7 +1307,7 @@ void vtoc_update_format7_label_del (form
  */
 void vtoc_set_freespace(format4_label_t *f4, format5_label_t *f5,
 		   format7_label_t *f7, char ch, int verbose,
-		   u_int32_t start, u_int32_t stop, int cyl, int trk)
+		   u_int32_t start, u_int32_t stop, u_int32_t cyl, u_int32_t trk)
 {
 	if ((cyl * trk) > BIG_DISK_SIZE) {
 		if (ch == '+') {
@@ -1211,8 +1325,7 @@ void vtoc_set_freespace(format4_label_t 
 		f4->DS4VTOCI = 0xa0;
 		f4->DS4EFLVL = 0x07;
 		vtoc_set_cchhb(&f4->DS4EFPTR, 0x0000, 0x0001, 0x03);
-	}
-	else {
+	} else {
 		u_int16_t x,y;
 		u_int8_t  z;
 
Index: s390-tools-sles11/man/Makefile
===================================================================
--- s390-tools-sles11.orig/man/Makefile
+++ s390-tools-sles11/man/Makefile
@@ -1,13 +1,20 @@
 include ../common.mak
 
+MANS = dumpconf.8 prandom.4 af_iucv.7
+
 all:
 
 clean:
 
-install:
-	$(INSTALL) -d -m 755 $(MANDIR)/man8
-	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dumpconf.8 $(MANDIR)/man8
-	$(INSTALL) -d -m 755 $(MANDIR)/man4
-	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 prandom.4 $(MANDIR)/man4
+install: $(MANS)
+	for man in $(MANS); do \
+	  msection=`echo $$man |sed 's/.*\.\([1-8]\)$$/man\1/'` ; \
+	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 -D $$man $(MANDIR)/$$msection/$$man ; \
+	done
+
+pdf: $(MANS)
+	for man in $(MANS); do \
+	  man -t ./$$man |ps2pdf -sPAPERSIZE=a4 - $${man}.pdf ; \
+	done
 
-.PHONY: all install clean
+.PHONY: all install clean pdf
Index: s390-tools-sles11/vmconvert/Makefile
===================================================================
--- s390-tools-sles11.orig/vmconvert/Makefile
+++ s390-tools-sles11/vmconvert/Makefile
@@ -1,8 +1,8 @@
 # Common definitions
 include ../common.mak
 
-CXXFLAGS      = $(CFLAGS) -D_FILE_OFFSET_BITS=64 -I../include
-OBJS          = main.o lkcd_dump.o vm_dump.o register_content.o dump.o
+CXXFLAGS      += -D_FILE_OFFSET_BITS=64 -I../include
+OBJS          = main.o lkcd_dump.o vm_dump.o register_content.o dump.o convert.o
 
 all: vmconvert
 
@@ -10,6 +10,7 @@ lkcd_dump.o: lkcd_dump.cpp lkcd_dump.h
 vm_dump.o: vm_dump.cpp vm_dump.h
 dump.o: dump.cpp dump.h
 register_content.o: register_content.cpp register_content.h
+convert.o: convert.cpp vm_dump.h lkcd_dump.h
 
 vmconvert: $(OBJS)
 	$(CXX) $(CXXFLAGS) -o vmconvert $(OBJS) -lz
Index: s390-tools-sles11/vmconvert/convert.cpp
===================================================================
--- /dev/null
+++ s390-tools-sles11/vmconvert/convert.cpp
@@ -0,0 +1,71 @@
+/*
+ * convert.cpp
+ *  dump convert program required by both vmconvert and vmur
+ *
+ *  Copyright IBM Corp. 2004, 2008.
+ *
+ *  Author(s): Michael Holzheu
+ */
+
+#include "vm_dump.h"
+#include "lkcd_dump.h"
+
+int
+vm_convert(const char* inputFileName, const char* outputFileName,
+	   const char* progName)
+{
+/* Do the conversion */
+	try {
+		switch(VMDump::getDumpType(inputFileName)){
+			case Dump::DT_VM64_BIG:
+			{
+				VMDump64Big* vmdump;
+				LKCDDump64* lkcddump;
+
+				vmdump = new VMDump64Big(inputFileName);
+				vmdump->printInfo();
+				lkcddump = new LKCDDump64(vmdump,
+						vmdump->getRegisterContent());
+				lkcddump->writeDump(outputFileName);
+				delete vmdump;
+				delete lkcddump;
+				break;
+			}
+			case Dump::DT_VM64:
+			{
+				VMDump64* vmdump;
+				LKCDDump64* lkcddump;
+
+				vmdump = new VMDump64(inputFileName);
+				vmdump->printInfo();
+				lkcddump = new LKCDDump64(vmdump,
+						vmdump->getRegisterContent());
+				lkcddump->writeDump(outputFileName);
+				delete vmdump;
+				delete lkcddump;
+				break;
+			}
+			case Dump::DT_VM32:
+			{
+				VMDump32* vmdump;
+				LKCDDump32* lkcddump;
+
+				vmdump = new VMDump32(inputFileName);
+				vmdump->printInfo();
+				lkcddump = new LKCDDump32(vmdump,
+						vmdump->getRegisterContent());
+				lkcddump->writeDump(outputFileName);
+				delete vmdump;
+				delete lkcddump;
+				break;
+			}
+			default:
+				throw DumpException("This is not a vmdump");
+		}
+	} catch (DumpException ex) {
+		printf("%s: %s\n", progName, ex.what());
+		fflush(stdout);
+		return 1;
+	}
+	return 0;
+}
Index: s390-tools-sles11/vmconvert/dump.cpp
===================================================================
--- s390-tools-sles11.orig/vmconvert/dump.cpp
+++ s390-tools-sles11/vmconvert/dump.cpp
@@ -47,17 +47,19 @@ void 
 ProgressBar::displayProgress(uint64_t value, uint64_t maxValue)
 {
 	int j;
-	printf("%6lld of %6lld |", (long long)value, (long long)maxValue);
-	if(progressPercentage != (int)(value*100/maxValue))
-	{
-		/* percent value has changed */
-		progressPercentage = (value*100/maxValue);
-		for (j=1; j<=progressPercentage/2; j++)
-			printf("#");
-		for (j=progressPercentage/2+1; j<=50; j++)
-			printf("-");
-		printf("| %3d%%  ", progressPercentage);
+	char progress_bar[50];
+
+	if (progressPercentage == (int) (value * 100 / maxValue))
+		fprintf(stderr, "%6lld of %6lld |\r",
+			(long long) value, (long long) maxValue);
+	else {  /* percent value has changed */
+		progressPercentage = (value * 100 / maxValue);
+		for (j = 0; j < progressPercentage / 2; j++)
+			progress_bar[j] = '#';
+		for (j = progressPercentage / 2; j < 50; j++)
+			progress_bar[j] = '-';
+		fprintf(stderr, "%6lld of %6lld |%s| %3d%%  \r",
+			(long long) value, (long long) maxValue,
+			progress_bar, progressPercentage);
 	}
-	printf("\r");
-	fflush(stdout);
 }
Index: s390-tools-sles11/vmconvert/dump.h
===================================================================
--- s390-tools-sles11.orig/vmconvert/dump.h
+++ s390-tools-sles11/vmconvert/dump.h
@@ -74,7 +74,22 @@ private:
 	int progressPercentage;
 };
 
-void s390TodToTimeval(uint64_t todval, struct timeval *xtime);
+extern void s390TodToTimeval(uint64_t todval, struct timeval *xtime);
+extern int vm_convert(const char* inputFileName, const char* outputFileName,
+		      const char* progName);
+
+static inline void dump_read(void *ptr, size_t size, size_t nmemb,
+			     FILE *stream)
+{
+	if (fread(ptr, size, nmemb, stream) != nmemb)
+		throw(DumpErrnoException("fread failed"));
+}
+
+static inline void dump_seek(FILE *stream, long offset, int whence)
+{
+	if (fseek(stream, offset, whence) == -1)
+		throw(DumpErrnoException("fseek failed"));
+}
 
 #endif /* DUMP_H */
 
Index: s390-tools-sles11/vmconvert/lkcd_dump.cpp
===================================================================
--- s390-tools-sles11.orig/vmconvert/lkcd_dump.cpp
+++ s390-tools-sles11/vmconvert/lkcd_dump.cpp
@@ -12,6 +12,8 @@
 
 #include <zlib.h>
 #include <string.h>
+#include <unistd.h>
+#include <fcntl.h>
 #include "lkcd_dump.h"
 
 LKCDDump::LKCDDump(Dump* dump, const char* arch){
@@ -65,39 +67,37 @@ LKCDDump::writeDump(const char* fileName
 	char dump_page_buf[DUMP_BUFFER_SIZE];
 	char dpcpage[DUMP_PAGE_SIZE];
 	char buf[DUMP_PAGE_SIZE];
+	char dump_header_buf[DUMP_HEADER_SIZE] = {};
 	uint32_t dp_size,dp_flags;
 	uint64_t mem_loc = 0;
-	uint64_t buf_loc = 0;
+	ssize_t buf_loc = 0;
 	struct _dump_page dp;
-	int size;
-	FILE* fh = NULL;
+	int size, fd;
 
-	fh = fopen(fileName,"w+");
-	if(!fh){
-		char msg[1024];
-		sprintf(msg, "Open of dump '%s' failed",fileName);
-		throw(DumpErrnoException(msg));
+	if (fileName == NULL)
+		fd = STDOUT_FILENO;
+	else {
+		fd = open(fileName, O_WRONLY | O_CREAT | O_TRUNC,
+			  S_IRUSR | S_IWUSR);
+		if (fd == -1) {
+			char msg[1024];
+			sprintf(msg, "Open of dump '%s' failed.", fileName);
+			throw(DumpErrnoException(msg));
+		}
 	}
 
 	/* write dump header */
 
-	if(fseek(fh, 0L, SEEK_SET) < 0) {
-		throw(DumpErrnoException("LKCDDump::writeDump "\
-					"- seek failed"));
-	}
-	if (fwrite((char *)&dumpHeader, sizeof(dumpHeader), 1,fh) != 1) {
+	memcpy(dump_header_buf, &dumpHeader, sizeof(dumpHeader));
+	if (write(fd, dump_header_buf, sizeof(dump_header_buf)) !=
+	    sizeof(dump_header_buf)) {
 		throw(DumpErrnoException("write failed"));
 	}
-	if(fseek(fh, DUMP_HEADER_SIZE, SEEK_SET) < 0) {
-		throw(DumpErrnoException("LKCDDump::writeDump "\
-					"- seek failed"));
-	}
 
 	/* write memory */
 
 	referenceDump->seekMem(0);
 
-	mem_loc = 0;
 	while (mem_loc < dumpHeader.memory_size) {
 		referenceDump->readMem(buf, DUMP_PAGE_SIZE);
 		copyRegsToPage(mem_loc,buf);
@@ -139,7 +139,7 @@ LKCDDump::writeDump(const char* fileName
 					(const void *)buf, dp_size);
 		}
 		buf_loc += dp_size;
-		if(fwrite(dump_page_buf, buf_loc, 1,fh) != 1){
+		if(write(fd, dump_page_buf, buf_loc) != buf_loc){
 			throw(DumpErrnoException("write failed"));
 		}
 		buf_loc = 0;
@@ -154,13 +154,12 @@ LKCDDump::writeDump(const char* fileName
 	dp.address = 0x0;
 	dp.size    = DUMP_DH_END;
 	dp.flags   = 0x0;
-	if(fwrite(dump_page_buf, sizeof(dp),1,fh) != 1){
+	if(write(fd, dump_page_buf, sizeof(dp)) != sizeof(dp)){
 		throw(DumpErrnoException("write failed"));
 	}
-	printf("\n\n");
-	fflush(stdout);
-	if(fh)
-		fclose(fh);
+	fprintf(stderr, "\n");
+	if (fd != STDOUT_FILENO)
+		close(fd);
 }
 
 struct timeval 
Index: s390-tools-sles11/vmconvert/main.cpp
===================================================================
--- s390-tools-sles11.orig/vmconvert/main.cpp
+++ s390-tools-sles11/vmconvert/main.cpp
@@ -7,14 +7,12 @@
  *  Author(s): Michael Holzheu
  */
 
-#include <stdio.h>
 #include <getopt.h>
 #include <stdlib.h>
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <unistd.h>
 #include "vm_dump.h"
-#include "lkcd_dump.h"
 #include "zt_common.h"
 
 static struct option longopts[] = {
@@ -30,10 +28,10 @@ extern char *optarg;
 
 /* Version info */
 static const char version_text[] = "vmconvert: vmdump converter tool version "\
-                                   RELEASE_STRING".";
+                                   RELEASE_STRING;
 
 /* Copyright notice */
-static const char copyright_notice[] = "Copyright IBM Corp. 2004, 2006.";
+static const char copyright_notice[] = "Copyright IBM Corp. 2004, 2006";
 
 /* Usage information */
 static const char usage_text[] = \
@@ -112,7 +110,8 @@ int
 main(int argc, char* argv[])
 {
 	struct stat s;
-	
+	int rc;
+
 	parseOpts(argc,argv);
 
 	/* Check if output file already exists */
@@ -123,60 +122,8 @@ main(int argc, char* argv[])
 		if((strcmp(answer,"y") != 0) && (strcmp(answer,"yes") != 0))
 			exit(0);
 	}
-
-	/* Do the conversion */
-	try {
-		switch(VMDump::getDumpType(inputFileName)){
-			case Dump::DT_VM64_BIG:
-			{
-				VMDump64Big* vmdump;
-				LKCDDump64* lkcddump;
-				 
-				vmdump = new VMDump64Big(inputFileName);
-				vmdump->printInfo();
-				lkcddump = new LKCDDump64(vmdump, 
-						vmdump->getRegisterContent());
-				lkcddump->writeDump(outputFileName);
-				delete vmdump;
-				delete lkcddump;
-				break;
-			}
-			case Dump::DT_VM64:
-			{
-				VMDump64* vmdump;
-				LKCDDump64* lkcddump;
-				
-				vmdump = new VMDump64(inputFileName);
-				vmdump->printInfo();
-				lkcddump = new LKCDDump64(vmdump, 
-						vmdump->getRegisterContent());
-				lkcddump->writeDump(outputFileName);
-				delete vmdump;
-				delete lkcddump;
-				break;
-			}
-			case Dump::DT_VM32:
-			{
-				VMDump32* vmdump;
-				LKCDDump32* lkcddump;
-				 
-				vmdump = new VMDump32(inputFileName);
-				vmdump->printInfo();
-				lkcddump = new LKCDDump32(vmdump, 
-						vmdump->getRegisterContent());
-				lkcddump->writeDump(outputFileName);
-				delete vmdump;
-				delete lkcddump;
-				break;
-			}
-			default:
-				throw DumpException("This is not a vmdump");
-		}
-	} catch (DumpException ex) {
-		printf("%s: %s\n",argv[0],ex.what());
-		fflush(stdout);
-		return 1;
-	}
-	printf("'%s' has been written successfully.\n",outputFileName);
-	return 0;
+	rc = vm_convert(inputFileName, outputFileName, argv[0]);
+	if (!rc)
+		printf("'%s' has been written successfully.\n", outputFileName);
+	return rc;
 }
Index: s390-tools-sles11/vmconvert/register_content.cpp
===================================================================
--- s390-tools-sles11.orig/vmconvert/register_content.cpp
+++ s390-tools-sles11/vmconvert/register_content.cpp
@@ -12,7 +12,7 @@
 #include "dump.h"
 
 RegisterContent32::RegisterContent32(void)
-	: nrCpus(0)
+	: regSets(), nrCpus(0)
 {
 }
 
@@ -44,7 +44,7 @@ RegisterContent32::getRegisterSet(int cp
 }
 
 RegisterContent64::RegisterContent64(void)
-	: nrCpus(0)
+	: regSets(), nrCpus(0)
 {
 }
 
